Since libpng-1.4, jmpbuf is no longer directly accessible, and we need
the macro png_jmpbuf. We also define this macro for older versions of
libpng.

--- png/pngread.c.orig	2012-02-27 15:54:49.000000000 +0100
+++ png/pngread.c	2012-02-27 15:55:14.000000000 +0100
@@ -15,6 +15,9 @@
 
 #if HAVE_PNG
 #include <png.h>
+#ifndef png_jmpbuf
+#define png_jmpbuf(ptr) ptr->jmpbuf
+#endif
 #endif
 
 #include <caml/mlvalues.h>
@@ -70,7 +73,7 @@
   }
 
   /* error handling */
-  if (setjmp(png_ptr->jmpbuf)) {
+  if (setjmp(png_jmpbuf(png_ptr))) {
     /* Free all of the memory associated with the png_ptr and info_ptr */
     png_destroy_read_struct(&png_ptr, &info_ptr, (png_infopp)NULL);
     fclose(fp);
@@ -126,7 +129,7 @@
     }
   
     /* Later, we can return something */
-    if (setjmp(png_ptr->jmpbuf)) {
+    if (setjmp(png_jmpbuf(png_ptr))) {
       /* Free all of the memory associated with the png_ptr and info_ptr */
       png_destroy_read_struct(&png_ptr, &info_ptr, (png_infopp)NULL);
       fclose(fp);
@@ -224,7 +227,7 @@
   }
 
   /* error handling */
-  if (setjmp(png_ptr->jmpbuf)) {
+  if (setjmp(png_jmpbuf(png_ptr))) {
     /* Free all of the memory associated with the png_ptr and info_ptr */
     png_destroy_read_struct(&png_ptr, &info_ptr, (png_infopp)NULL);
     fclose(fp);
@@ -328,7 +331,7 @@
     }
   
     /* Later, we can return something */
-    if (setjmp(png_ptr->jmpbuf)) {
+    if (setjmp(png_jmpbuf(png_ptr))) {
       /* Free all of the memory associated with the png_ptr and info_ptr */
       png_destroy_read_struct(&png_ptr, &info_ptr, (png_infopp)NULL);
       fclose(fp);
